.586
.MMX
.Model Flat, StdCall
option casemap:none

include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include \masm32\include\gdi32.inc
include \masm32\include\comctl32.inc
include \masm32\include\comdlg32.inc
include \masm32\include\shell32.inc
;---
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\comctl32.lib
includelib \masm32\lib\comdlg32.lib
includelib \masm32\lib\shell32.lib
;---
include \masm32\include\windows.inc

; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.const
align 8
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
WP_CallBack             equ [ebp+04]                    ; return address
WP_hWnd                 equ [ebp+08]                    ; handle window for msg
WP_uMsg                 equ [ebp+12]                    ; message number
WP_wParam               equ [ebp+16]                    ; extra message info
WP_lParam               equ [ebp+20]                    ; extra message info

; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.data?
align 8
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
wc                          WNDCLASSEX <>                   ; Structures
msg                         MSG <>
icc                         INITCOMMONCONTROLSEX <>
ps                          PAINTSTRUCT <>
cbei                        COMBOBOXEXITEM <>
;---
ReturnEAX                   dd ?
;---
hInstance                   dd ?
hFntDefGui                  dd ?
hWndCBEx                    dd ?

; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.data
align 8
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
_MaxTblString               dd 7
_TblString                  dd OFFSET szString1
                            dd OFFSET szString2
                            dd OFFSET szString3
                            dd OFFSET szString4
                            dd OFFSET szString5
                            dd OFFSET szString6
                            dd OFFSET szString7
;---
szCN                        db "4i28567676",0
szWN                        db "ComboBoxEx",0
CN_ComboBoxEx               db "ComboBoxEx32",0
;---
szString1                   db "Item 1",0
szString2                   db "Item 2",0
szString3                   db "Item 3",0
szString4                   db "Item 4",0
szString5                   db "Item five",0
szString6                   db "Item six",0
szString7                   db "Item seven",0

; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.code
align 8
Main:
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
invoke  GetModuleHandle,0
mov     wc.hInstance,eax
mov     hInstance,eax
;---
mov     icc.dwSize,sizeof INITCOMMONCONTROLSEX
mov     icc.dwICC,ICC_STANDARD_CLASSES or ICC_WIN95_CLASSES
invoke  InitCommonControlsEx,ADDR icc
;---
mov     wc.hIconSm,0
mov     wc.hIcon,0
invoke  LoadCursor,0,IDC_ARROW
mov     wc.hCursor,eax
mov     wc.hbrBackground,COLOR_BTNFACE+1
mov     wc.cbSize,sizeof WNDCLASSEX
mov     wc.style,CS_HREDRAW or CS_VREDRAW
mov     wc.lpfnWndProc,OFFSET WP
mov     wc.cbClsExtra,0
mov     wc.cbWndExtra,0
mov     wc.lpszMenuName,0
mov     wc.lpszClassName,OFFSET szCN
invoke  RegisterClassEx,ADDR wc
;---
invoke  CreateWindowEx,0,ADDR szCN,ADDR szWN,WS_OVERLAPPED or WS_CAPTION or WS_CLIPCHILDREN or WS_SYSMENU or WS_MINIMIZEBOX,128,128,480,320,0,0,wc.hInstance,0
mov     msg.hwnd,eax
invoke  ShowWindow,msg.hwnd,SW_SHOWNORMAL
invoke  UpdateWindow,msg.hwnd



; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
MessageLoop:
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
invoke  GetMessage,ADDR msg,0,0,0
cmp     eax,0h
je      TerminateProgram
invoke  TranslateMessage,ADDR msg
invoke  DispatchMessage,ADDR msg
jmp     MessageLoop
; -------------------------------------------------------------------------
TerminateProgram:
invoke  ExitProcess,wc.hInstance
mov     eax,msg.wParam
ret



; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
WP:
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
push    ebp
mov     ebp,esp
pushad
mov     eax,WP_uMsg
; -------------------------------------------------------------------------
WP_WM_CREATE:
cmp     eax,WM_CREATE
jne     WP_WM_DESTROY
; -------------------------------------------------------------------------
invoke  GetStockObject,DEFAULT_GUI_FONT
mov     hFntDefGui,eax
;---
invoke  CreateWindowEx,0,ADDR CN_ComboBoxEx,0,WS_CHILD or WS_VISIBLE or WS_VSCROLL or CBS_DROPDOWNLIST or CBS_AUTOHSCROLL or CBS_NOINTEGRALHEIGHT,15,38,320,240,WP_hWnd,1000,wc.hInstance,0
mov     hWndCBEx,eax
invoke  SendMessage,hWndCBEx,WM_SETFONT,hFntDefGui,1

mov     cbei._mask,CBEIF_TEXT
mov     cbei.iItem,-1
mov     ebx,0
mov     esi,OFFSET _TblString
CBExLoop:
mov     eax,[esi]
mov     cbei.pszText,eax
invoke  SendMessage,hWndCBEx,CBEM_INSERTITEM,0,ADDR cbei
add     esi,4
inc     ebx
cmp     ebx,_MaxTblString
jne     CBExLoop

invoke SendMessage,hWndCBEx,CB_SETCURSEL,0,0
;---
jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_DESTROY:
cmp     eax,WM_DESTROY
jne     WP_WM_PAINT
; -------------------------------------------------------------------------
invoke  PostQuitMessage,0
popad
xor     eax,eax
mov     esp,ebp
pop     ebp
ret     10h

; -------------------------------------------------------------------------
WP_WM_PAINT:
cmp     eax,WM_PAINT
jne     WP_WM_NOTIFY
; -------------------------------------------------------------------------

jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_NOTIFY:
cmp     eax,WM_NOTIFY
jne     WP_WM_DISPLAYCHANGE
; -------------------------------------------------------------------------
mov     ebx,WP_lParam 
mov     eax,[ebx+0]
cmp     eax,hWndCBEx
jne     WP_Return
;---

;---
jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_DISPLAYCHANGE:
cmp     eax,WM_DISPLAYCHANGE
jne     WP_WM_COMMAND
; -------------------------------------------------------------------------
invoke  InvalidateRect,WP_hWnd,0,0
jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_COMMAND:
cmp     eax,WM_COMMAND
jne     WP_WM_POWERBROADCAST
mov     eax,WP_wParam                           ; control or menu ID in ax
; -------------------------------------------------------------------------

jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_POWERBROADCAST:
cmp     eax,WM_POWERBROADCAST
jne     WP_Return
; -------------------------------------------------------------------------
mov     eax,WP_wParam
cmp     eax,PBT_APMRESUMESUSPEND
jne     WP_Return
mov     eax,WP_lParam
cmp     eax,PBTF_APMRESUMEFROMFAILURE
je      WP_Return
invoke  RedrawWindow,WP_hWnd,0,0,RDW_ERASE or RDW_INVALIDATE or RDW_UPDATENOW
jmp     WP_Return

; -------------------------------------------------------------------------
WP_Return:
; -------------------------------------------------------------------------
popad
invoke  DefWindowProc,WP_hWnd,WP_uMsg,WP_wParam,WP_lParam
mov     esp,ebp                                 ; delete stack frame
pop     ebp
ret     10h                                     ; return and clear stack
; -------------------------------------------------------------------------
WP_Return0:
; -------------------------------------------------------------------------
popad
mov     eax,0
mov     esp,ebp                                 ; delete stack frame
pop     ebp
ret     10h                                     ; return and clear stack
; -------------------------------------------------------------------------
WP_Return1:
; -------------------------------------------------------------------------
popad
mov     eax,1
mov     esp,ebp                                 ; delete stack frame
pop     ebp
ret     10h                                     ; return and clear stack
; -------------------------------------------------------------------------
WP_ReturnEAX:
; -------------------------------------------------------------------------
popad
mov     eax,ReturnEAX
mov     esp,ebp                                 ; delete stack frame
pop     ebp
ret     10h                                     ; return and clear stack

; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
end Main
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

